diff --git a/Modules/Segmentation/Watersheds/test/itkMorphologicalWatershedImageFilterTest.cxx b/Modules/Segmentation/Watersheds/test/itkMorphologicalWatershedImageFilterTest.cxx
index 6cc8e20665..cbe23086b2 100644
--- a/Modules/Segmentation/Watersheds/test/itkMorphologicalWatershedImageFilterTest.cxx
+++ b/Modules/Segmentation/Watersheds/test/itkMorphologicalWatershedImageFilterTest.cxx
@@ -25,106 +25,101 @@
 #include "itkTestingMacros.h"
 
 
-int itkMorphologicalWatershedImageFilterTest( int argc, char * argv[] )
+int
+itkMorphologicalWatershedImageFilterTest(int argc, char * argv[])
 {
-  if( argc < 6 )
-    {
+  if (argc < 6)
+  {
     std::cerr << "Missing parameters" << std::endl;
-    std::cerr << "Usage: " << argv[0]
-      << " inputImageFile"
-      << " outputImageFile"
-      << " markWatershedLine"
-      << " fullyConnected"
-      << " level"
-      << " [ovelayOutput [alpha]]";
+    std::cerr << "Usage: " << itkNameOfTestExecutableMacro(argv) << " inputImageFile"
+              << " outputImageFile"
+              << " markWatershedLine"
+              << " fullyConnected"
+              << " level"
+              << " [ovelayOutput [alpha]]";
     std::cerr << std::endl;
     return EXIT_FAILURE;
-    }
+  }
 
-  const unsigned int Dimension = 2;
+  constexpr unsigned int Dimension = 2;
 
-  typedef unsigned char PixelType;
+  using PixelType = unsigned char;
 
-  typedef itk::Image< PixelType, Dimension > ImageType;
+  using ImageType = itk::Image<PixelType, Dimension>;
 
-  typedef itk::ImageFileReader< ImageType > ReaderType;
+  using ReaderType = itk::ImageFileReader<ImageType>;
   ReaderType::Pointer reader = ReaderType::New();
-  reader->SetFileName( argv[1] );
+  reader->SetFileName(argv[1]);
 
-  typedef itk::MorphologicalWatershedImageFilter< ImageType, ImageType >
-    FilterType;
+  using FilterType = itk::MorphologicalWatershedImageFilter<ImageType, ImageType>;
   FilterType::Pointer filter = FilterType::New();
 
-  EXERCISE_BASIC_OBJECT_METHODS( filter, MorphologicalWatershedImageFilter,
-    ImageToImageFilter );
+  ITK_EXERCISE_BASIC_OBJECT_METHODS(filter, MorphologicalWatershedImageFilter, ImageToImageFilter);
 
-  bool markWatershedLine = atoi( argv[3] );
-  TEST_SET_GET_BOOLEAN( filter, MarkWatershedLine, markWatershedLine );
+  bool markWatershedLine = std::stoi(argv[3]);
+  ITK_TEST_SET_GET_BOOLEAN(filter, MarkWatershedLine, markWatershedLine);
 
-  bool fullyConnected = atoi( argv[4] );
-  TEST_SET_GET_BOOLEAN( filter, FullyConnected, fullyConnected );
+  bool fullyConnected = std::stoi(argv[4]);
+  ITK_TEST_SET_GET_BOOLEAN(filter, FullyConnected, fullyConnected);
 
-  FilterType::InputImagePixelType level =
-    static_cast< FilterType::InputImagePixelType >( atof( argv[5] ) );
-  filter->SetLevel( level );
-  TEST_SET_GET_VALUE( level, filter->GetLevel() );
+  auto level = static_cast<FilterType::InputImagePixelType>(std::stod(argv[5]));
+  filter->SetLevel(level);
+  ITK_TEST_SET_GET_VALUE(level, filter->GetLevel());
 
 
-  filter->SetInput( reader->GetOutput() );
+  filter->SetInput(reader->GetOutput());
 
-  itk::SimpleFilterWatcher watcher( filter, "MorphologicalWatershedImageFilter" );
+  itk::SimpleFilterWatcher watcher(filter, "MorphologicalWatershedImageFilter");
 
-  TRY_EXPECT_NO_EXCEPTION( filter->Update() );
+  ITK_TRY_EXPECT_NO_EXCEPTION(filter->Update());
 
 
   // Rescale the output to have a better display
-  typedef itk::MinimumMaximumImageCalculator< ImageType > MaxCalculatorType;
+  using MaxCalculatorType = itk::MinimumMaximumImageCalculator<ImageType>;
   MaxCalculatorType::Pointer minMaxCalculator = MaxCalculatorType::New();
-  minMaxCalculator->SetImage( filter->GetOutput() );
+  minMaxCalculator->SetImage(filter->GetOutput());
   minMaxCalculator->Compute();
 
-  typedef itk::IntensityWindowingImageFilter<
-    ImageType, ImageType > RescaleType;
+  using RescaleType = itk::IntensityWindowingImageFilter<ImageType, ImageType>;
   RescaleType::Pointer rescaler = RescaleType::New();
-  rescaler->SetInput( filter->GetOutput() );
-  rescaler->SetWindowMinimum( itk::NumericTraits< PixelType >::ZeroValue() );
-  rescaler->SetWindowMaximum( minMaxCalculator->GetMaximum() );
-  rescaler->SetOutputMaximum( itk::NumericTraits< PixelType >::max() );
-  rescaler->SetOutputMinimum( itk::NumericTraits< PixelType >::ZeroValue() );
+  rescaler->SetInput(filter->GetOutput());
+  rescaler->SetWindowMinimum(itk::NumericTraits<PixelType>::ZeroValue());
+  rescaler->SetWindowMaximum(minMaxCalculator->GetMaximum());
+  rescaler->SetOutputMaximum(itk::NumericTraits<PixelType>::max());
+  rescaler->SetOutputMinimum(itk::NumericTraits<PixelType>::ZeroValue());
 
   // Write output image
-  typedef itk::ImageFileWriter< ImageType > WriterType;
+  using WriterType = itk::ImageFileWriter<ImageType>;
   WriterType::Pointer writer = WriterType::New();
-  writer->SetInput( rescaler->GetOutput() );
-  writer->SetFileName( argv[2] );
+  writer->SetInput(rescaler->GetOutput());
+  writer->SetFileName(argv[2]);
 
-  TRY_EXPECT_NO_EXCEPTION( writer->Update() );
+  ITK_TRY_EXPECT_NO_EXCEPTION(writer->Update());
 
-  if( argc > 6 )
-    {
-    typedef itk::RGBPixel< PixelType >            RGBPixelType;
-    typedef itk::Image< RGBPixelType, Dimension > RGBImageType;
+  if (argc > 6)
+  {
+    using RGBPixelType = itk::RGBPixel<PixelType>;
+    using RGBImageType = itk::Image<RGBPixelType, Dimension>;
 
-    typedef itk::LabelOverlayImageFilter<
-      ImageType, ImageType, RGBImageType> OverlayType;
+    using OverlayType = itk::LabelOverlayImageFilter<ImageType, ImageType, RGBImageType>;
 
     OverlayType::Pointer overlay = OverlayType::New();
-    overlay->SetInput( reader->GetOutput() );
-    overlay->SetLabelImage( filter->GetOutput() );
+    overlay->SetInput(reader->GetOutput());
+    overlay->SetLabelImage(filter->GetOutput());
 
-    typedef itk::ImageFileWriter< RGBImageType > RGBWriterType;
+    using RGBWriterType = itk::ImageFileWriter<RGBImageType>;
     RGBWriterType::Pointer rgbwriter = RGBWriterType::New();
-    rgbwriter->SetInput( overlay->GetOutput() );
-    rgbwriter->SetFileName( argv[6] );
+    rgbwriter->SetInput(overlay->GetOutput());
+    rgbwriter->SetFileName(argv[6]);
 
-    if( argc > 7 )
-      {
-      overlay->SetOpacity( atof( argv[7] ) );
-      }
-
-    TRY_EXPECT_NO_EXCEPTION( rgbwriter->Update() );
+    if (argc > 7)
+    {
+      overlay->SetOpacity(std::stod(argv[7]));
     }
 
+    ITK_TRY_EXPECT_NO_EXCEPTION(rgbwriter->Update());
+  }
+
   std::cerr << "Test finished" << std::endl;
   return EXIT_SUCCESS;
 }
diff --git a/Modules/Segmentation/Watersheds/test/itkTobogganImageFilterTest.cxx b/Modules/Segmentation/Watersheds/test/itkTobogganImageFilterTest.cxx
index feafaa48c0..b12803a56e 100644
--- a/Modules/Segmentation/Watersheds/test/itkTobogganImageFilterTest.cxx
+++ b/Modules/Segmentation/Watersheds/test/itkTobogganImageFilterTest.cxx
@@ -25,75 +25,70 @@
 #include "itkTestingMacros.h"
 
 
-int itkTobogganImageFilterTest( int argc, char* argv[] )
+int
+itkTobogganImageFilterTest(int argc, char * argv[])
 {
-  if( argc < 3 )
-    {
+  if (argc < 3)
+  {
     std::cerr << "Missing parameters" << std::endl;
-    std::cerr << "Usage: " << argv[0] << " InputImage OutputImage" << std::endl;
+    std::cerr << "Usage: " << itkNameOfTestExecutableMacro(argv) << " InputImage OutputImage" << std::endl;
     return EXIT_FAILURE;
-    }
+  }
 
-  const unsigned int Dimension = 2;
+  constexpr unsigned int Dimension = 2;
 
-  typedef unsigned char                                 PixelType;
-  typedef float                                         FloatPixelType;
-  typedef itk::Image< PixelType, Dimension >            InputImageType;
-  typedef itk::Image< FloatPixelType, Dimension >       FloatImageType;
-  typedef itk::Image< PixelType, Dimension >            OutputImageType;
-  typedef itk::Image< itk::IdentifierType, Dimension >  LongImageType;
+  using PixelType = unsigned char;
+  using FloatPixelType = float;
+  using InputImageType = itk::Image<PixelType, Dimension>;
+  using FloatImageType = itk::Image<FloatPixelType, Dimension>;
+  using OutputImageType = itk::Image<PixelType, Dimension>;
+  using LongImageType = itk::Image<itk::IdentifierType, Dimension>;
 
 
   // Create a pipeline
-  typedef itk::CastImageFilter< InputImageType, FloatImageType >
-                                           InputCastFilterType;
-  typedef itk::TobogganImageFilter< FloatImageType >
-                                           FilterType;
-  typedef itk::CastImageFilter< LongImageType, OutputImageType >
-                                           OutputCastFilterType;
-  typedef itk::GradientMagnitudeRecursiveGaussianImageFilter< FloatImageType, FloatImageType >
-                                           GMGaussianType;
+  using InputCastFilterType = itk::CastImageFilter<InputImageType, FloatImageType>;
+  using FilterType = itk::TobogganImageFilter<FloatImageType>;
+  using OutputCastFilterType = itk::CastImageFilter<LongImageType, OutputImageType>;
+  using GMGaussianType = itk::GradientMagnitudeRecursiveGaussianImageFilter<FloatImageType, FloatImageType>;
 
 
-  itk::ImageFileReader< InputImageType >::Pointer reader =
-    itk::ImageFileReader< InputImageType >::New();
+  itk::ImageFileReader<InputImageType>::Pointer reader = itk::ImageFileReader<InputImageType>::New();
 
-  reader->SetFileName( argv[1] );
+  reader->SetFileName(argv[1]);
 
-  TRY_EXPECT_NO_EXCEPTION( reader->Update() );
+  ITK_TRY_EXPECT_NO_EXCEPTION(reader->Update());
 
 
   FilterType::Pointer toboggan = FilterType::New();
 
-  EXERCISE_BASIC_OBJECT_METHODS( toboggan, TobogganImageFilter,
-    ImageToImageFilter );
+  ITK_EXERCISE_BASIC_OBJECT_METHODS(toboggan, TobogganImageFilter, ImageToImageFilter);
 
   InputCastFilterType::Pointer inputCaster = InputCastFilterType::New();
-  GMGaussianType::Pointer gmgaussian = GMGaussianType::New();
+  GMGaussianType::Pointer      gmgaussian = GMGaussianType::New();
 
-  inputCaster->SetInput( reader->GetOutput() );
-  gmgaussian->SetInput( inputCaster->GetOutput() );
-  gmgaussian->SetSigma( 15.0 );
+  inputCaster->SetInput(reader->GetOutput());
+  gmgaussian->SetInput(inputCaster->GetOutput());
+  gmgaussian->SetSigma(15.0);
 
-  toboggan->SetInput( gmgaussian->GetOutput() );
+  toboggan->SetInput(gmgaussian->GetOutput());
 
 
-  TRY_EXPECT_NO_EXCEPTION( toboggan->Update() );
+  ITK_TRY_EXPECT_NO_EXCEPTION(toboggan->Update());
 
 
   // Cast the output of the Toboggan filter
   OutputCastFilterType::Pointer outputCaster = OutputCastFilterType::New();
-  outputCaster->SetInput( toboggan->GetOutput() );
+  outputCaster->SetInput(toboggan->GetOutput());
 
-  TRY_EXPECT_NO_EXCEPTION( outputCaster->Update() );
+  ITK_TRY_EXPECT_NO_EXCEPTION(outputCaster->Update());
 
   // Write the output
-  typedef itk::ImageFileWriter< OutputImageType > WriterType;
+  using WriterType = itk::ImageFileWriter<OutputImageType>;
   WriterType::Pointer writer = WriterType::New();
-  writer->SetInput( outputCaster->GetOutput() );
-  writer->SetFileName( argv[2] );
+  writer->SetInput(outputCaster->GetOutput());
+  writer->SetFileName(argv[2]);
 
-  TRY_EXPECT_NO_EXCEPTION( writer->Update() );
+  ITK_TRY_EXPECT_NO_EXCEPTION(writer->Update());
 
 
   std::cout << "Test finished." << std::endl;
diff --git a/Modules/Segmentation/Watersheds/test/itkWatershedImageFilterTest.cxx b/Modules/Segmentation/Watersheds/test/itkWatershedImageFilterTest.cxx
index 61dd61f44d..ca68631741 100644
--- a/Modules/Segmentation/Watersheds/test/itkWatershedImageFilterTest.cxx
+++ b/Modules/Segmentation/Watersheds/test/itkWatershedImageFilterTest.cxx
@@ -19,51 +19,51 @@
 #include "itkWatershedImageFilter.h"
 #include "itkWatershedEquivalenceRelabeler.h"
 #include "itkWatershedBoundaryResolver.h"
-#include "itkFilterWatcher.h"
+#include "itkSimpleFilterWatcher.h"
 #include "itkTestingMacros.h"
 
 
-int itkWatershedImageFilterTest( int, char* [] )
+int
+itkWatershedImageFilterTest(int, char *[])
 {
 
-  const unsigned int Dimension = 2;
+  constexpr unsigned int Dimension = 2;
 
-  typedef float                                         PixelType;
-  typedef itk::Image< PixelType, Dimension >            ImageType2D;
-  typedef itk::Image< itk::IdentifierType, Dimension >  LongImageType2D;
+  using PixelType = float;
+  using ImageType2D = itk::Image<PixelType, Dimension>;
+  using LongImageType2D = itk::Image<itk::IdentifierType, Dimension>;
 
 
-  itk::ImageRegion< Dimension > region;
+  itk::ImageRegion<Dimension> region;
 
-  itk::Size< Dimension > size;
+  itk::Size<Dimension> size;
   size[0] = 314;
   size[1] = 314;
 
-  itk::Index< Dimension > origin;
+  itk::Index<Dimension> origin;
   origin[0] = 0;
   origin[1] = 0;
 
-  region.SetSize( size );
-  region.SetIndex( origin );
+  region.SetSize(size);
+  region.SetIndex(origin);
 
   ImageType2D::Pointer image2D = ImageType2D::New();
-  image2D->SetLargestPossibleRegion( region);
-  image2D->SetBufferedRegion( region );
-  image2D->SetRequestedRegion( region );
+  image2D->SetLargestPossibleRegion(region);
+  image2D->SetBufferedRegion(region);
+  image2D->SetRequestedRegion(region);
   image2D->Allocate();
 
   LongImageType2D::Pointer longimage2D = LongImageType2D::New();
-  longimage2D->SetRegions( region );
-  longimage2D->Allocate( true ); // initialize buffer to zero
+  longimage2D->SetRegions(region);
+  longimage2D->Allocate(true); // initialize buffer to zero
 
-  itk::ImageRegionIterator< ImageType2D > it2D( image2D,
-    image2D->GetRequestedRegion() );
+  itk::ImageRegionIterator<ImageType2D> it2D(image2D, image2D->GetRequestedRegion());
 
-  for( float q = 0.00f; !it2D.IsAtEnd(); ++it2D )
-    {
-    it2D.Value() = std::sin( q );
+  for (float q = 0.00f; !it2D.IsAtEnd(); ++it2D)
+  {
+    it2D.Value() = std::sin(q);
     q += 0.10f;
-    }
+  }
 
   // Test various objects associated to itk::WatershedImageFilter
   //
@@ -71,87 +71,79 @@ int itkWatershedImageFilterTest( int, char* [] )
   // Test EquivalenceRelabeler
   itk::EquivalencyTable::Pointer table = itk::EquivalencyTable::New();
 
-  itk::watershed::EquivalenceRelabeler<
-    LongImageType2D::PixelType, Dimension >::Pointer eq =
-    itk::watershed::EquivalenceRelabeler<
-    LongImageType2D::PixelType, Dimension >::New();
-  eq->SetInputImage( longimage2D );
+  itk::watershed::EquivalenceRelabeler<LongImageType2D::PixelType, Dimension>::Pointer eq =
+    itk::watershed::EquivalenceRelabeler<LongImageType2D::PixelType, Dimension>::New();
+  eq->SetInputImage(longimage2D);
 
-  eq->SetEquivalencyTable( table );
-  TEST_SET_GET_VALUE( table, eq->GetEquivalencyTable() );
+  eq->SetEquivalencyTable(table);
+  ITK_TEST_SET_GET_VALUE(table, eq->GetEquivalencyTable());
 
 
-  TRY_EXPECT_NO_EXCEPTION( eq->Update() );
+  ITK_TRY_EXPECT_NO_EXCEPTION(eq->Update());
 
   // Test WatershedMiniPipelineProgressCommand
   // Forcing the execution of the const Execute method which is not normally called.
-  itk::WatershedMiniPipelineProgressCommand::Pointer wmppc =
-    itk::WatershedMiniPipelineProgressCommand::New();
+  itk::WatershedMiniPipelineProgressCommand::Pointer wmppc = itk::WatershedMiniPipelineProgressCommand::New();
 
-  EXERCISE_BASIC_OBJECT_METHODS( wmppc, WatershedMiniPipelineProgressCommand,
-    Command );
+  ITK_EXERCISE_BASIC_OBJECT_METHODS(wmppc, WatershedMiniPipelineProgressCommand, Command);
 
   double count = 2.0;
-  wmppc->SetCount( count );
-  TEST_SET_GET_VALUE( count, wmppc->GetCount() );
+  wmppc->SetCount(count);
+  ITK_TEST_SET_GET_VALUE(count, wmppc->GetCount());
 
   unsigned int numberOfFilters = 2;
-  wmppc->SetNumberOfFilters( numberOfFilters );
-  TEST_SET_GET_VALUE( numberOfFilters, wmppc->GetNumberOfFilters() );
+  wmppc->SetNumberOfFilters(numberOfFilters);
+  ITK_TEST_SET_GET_VALUE(numberOfFilters, wmppc->GetNumberOfFilters());
 
-  wmppc->SetFilter( eq );
-  TEST_SET_GET_VALUE( eq, wmppc->GetFilter() );
+  wmppc->SetFilter(eq);
+  ITK_TEST_SET_GET_VALUE(eq, wmppc->GetFilter());
 
-  const itk::ProcessObject *constp = eq.GetPointer();
-  wmppc->Execute( constp, itk::ProgressEvent() );
-  wmppc->Execute( eq.GetPointer(), itk::ProgressEvent() );
+  const itk::ProcessObject * constp = eq.GetPointer();
+  wmppc->Execute(constp, itk::ProgressEvent());
+  wmppc->Execute(eq, itk::ProgressEvent());
 
   // Test watershed::BoundaryResolver
-  itk::watershed::BoundaryResolver< PixelType, Dimension >::Pointer br =
-    itk::watershed::BoundaryResolver< PixelType, Dimension >::New();
-  if( br.IsNull() )
-    {
+  itk::watershed::BoundaryResolver<PixelType, Dimension>::Pointer br =
+    itk::watershed::BoundaryResolver<PixelType, Dimension>::New();
+  if (br.IsNull())
+  {
     std::cerr << "Test failed!" << std::endl;
     std::cout << "Null itk::watershed::BoundaryResolver." << std::endl;
     return EXIT_FAILURE;
-    }
-  itk::watershed::Boundary< PixelType, 1 >::Pointer boundaryA =
-    itk::watershed::Boundary< PixelType, 1 >::New();
-  if( boundaryA.IsNull() )
-    {
+  }
+  itk::watershed::Boundary<PixelType, 1>::Pointer boundaryA = itk::watershed::Boundary<PixelType, 1>::New();
+  if (boundaryA.IsNull())
+  {
     std::cerr << "Test failed!" << std::endl;
     std::cout << "Null itk::watershed::Boundary." << std::endl;
     return EXIT_FAILURE;
-    }
-  itk::watershed::Boundary< PixelType, 1 >::Pointer boundaryB =
-    itk::watershed::Boundary< PixelType, 1 >::New();
-  if( boundaryB.IsNull() )
-    {
+  }
+  itk::watershed::Boundary<PixelType, 1>::Pointer boundaryB = itk::watershed::Boundary<PixelType, 1>::New();
+  if (boundaryB.IsNull())
+  {
     std::cerr << "Test failed!" << std::endl;
     std::cout << "Null itk::watershed::Boundary." << std::endl;
     return EXIT_FAILURE;
-    }
+  }
 
 
-  itk::WatershedImageFilter< ImageType2D >::Pointer watershedFilter =
-    itk::WatershedImageFilter< ImageType2D >::New();
+  itk::WatershedImageFilter<ImageType2D>::Pointer watershedFilter = itk::WatershedImageFilter<ImageType2D>::New();
 
-  EXERCISE_BASIC_OBJECT_METHODS( watershedFilter, WatershedImageFilter,
-    ImageToImageFilter );
+  ITK_EXERCISE_BASIC_OBJECT_METHODS(watershedFilter, WatershedImageFilter, ImageToImageFilter);
 
-  FilterWatcher watchIt( watershedFilter, "WatershedImageFilter" );
+  itk::SimpleFilterWatcher watchIt(watershedFilter, "WatershedImageFilter");
 
   double threshold = .05;
-  watershedFilter->SetThreshold( threshold );
-  TEST_SET_GET_VALUE( threshold, watershedFilter->GetThreshold() );
+  watershedFilter->SetThreshold(threshold);
+  ITK_TEST_SET_GET_VALUE(threshold, watershedFilter->GetThreshold());
 
   double level = 1.0;
-  watershedFilter->SetLevel( level );
-  TEST_SET_GET_VALUE( level, watershedFilter->GetLevel() );
+  watershedFilter->SetLevel(level);
+  ITK_TEST_SET_GET_VALUE(level, watershedFilter->GetLevel());
 
-  watershedFilter->SetInput( image2D );
+  watershedFilter->SetInput(image2D);
 
-  TRY_EXPECT_NO_EXCEPTION( watershedFilter->Update() );
+  ITK_TRY_EXPECT_NO_EXCEPTION(watershedFilter->Update());
 
 
   std::cout << "Test finished." << std::endl;
diff --git a/Modules/Segmentation/Watersheds/wrapping/test/CMakeLists.txt b/Modules/Segmentation/Watersheds/wrapping/test/CMakeLists.txt
new file mode 100644
index 0000000000..5c7b9206d4
--- /dev/null
+++ b/Modules/Segmentation/Watersheds/wrapping/test/CMakeLists.txt
@@ -0,0 +1,14 @@
+set(test_input_dir ${itk-module_SOURCE_DIR}/test/Input)
+set(test_baseline_dir ${itk-module_SOURCE_DIR}/test/Baseline)
+
+list(FIND ITK_WRAP_IMAGE_DIMS 2 wrap_2_index)
+if(ITK_WRAP_float AND wrap_2_index GREATER -1)
+  itk_python_add_test(NAME PythonWatershedSegmentation1Test
+    TEST_DRIVER_ARGS
+      --compare ${ITK_TEST_OUTPUT_DIR}/PythonWatershedSegmentation1Test.png
+                DATA{${test_baseline_dir}/PythonWatershedSegmentation1Test.png}
+    COMMAND WatershedSegmentation1Test.py
+      DATA{${test_input_dir}/VisibleWomanEyeSlice.png}
+      ${ITK_TEST_OUTPUT_DIR}/PythonWatershedSegmentation1Test.png
+    )
+endif()
diff --git a/Modules/Segmentation/Watersheds/wrapping/test/WatershedSegmentation1Test.py b/Modules/Segmentation/Watersheds/wrapping/test/WatershedSegmentation1Test.py
new file mode 100644
index 0000000000..0b3d5d0305
--- /dev/null
+++ b/Modules/Segmentation/Watersheds/wrapping/test/WatershedSegmentation1Test.py
@@ -0,0 +1,47 @@
+#==========================================================================
+#
+#   Copyright Insight Software Consortium
+#
+#   Licensed under the Apache License, Version 2.0 (the "License");
+#   you may not use this file except in compliance with the License.
+#   You may obtain a copy of the License at
+#
+#          http://www.apache.org/licenses/LICENSE-2.0.txt
+#
+#   Unless required by applicable law or agreed to in writing, software
+#   distributed under the License is distributed on an "AS IS" BASIS,
+#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+#   See the License for the specific language governing permissions and
+#   limitations under the License.
+#
+#==========================================================================*/
+
+import itk
+import sys
+itk.auto_progress(2)
+
+PixelType = itk.ctype('float')
+Dimension = 2
+ImageType = itk.Image[PixelType, Dimension]
+reader = itk.ImageFileReader[ImageType].New()
+reader.SetFileName(sys.argv[1])
+
+diffusion = itk.GradientAnisotropicDiffusionImageFilter.New(Input=reader.GetOutput())
+diffusion.SetTimeStep(0.0625)
+diffusion.SetConductanceParameter(9.0)
+diffusion.SetNumberOfIterations(5)
+
+gradient = itk.GradientMagnitudeImageFilter.New(Input=diffusion.GetOutput())
+
+watershed = itk.WatershedImageFilter.New(Input=gradient.GetOutput())
+watershed.SetThreshold(0.01)
+watershed.SetLevel(0.2)
+
+relabel = itk.RelabelComponentImageFilter.New(Input=watershed.GetOutput())
+
+cast = itk.CastImageFilter[relabel.GetOutput().__class__,
+  itk.Image[itk.ctype('unsigned char'), Dimension]].New(Input=relabel.GetOutput())
+
+writer = itk.ImageFileWriter.New(Input=cast.GetOutput())
+writer.SetFileName(sys.argv[2])
+writer.Update()
